Subject: [Netconf] transport independence (was Re: Opinion poll for the RESTCONF encoding)

From: Andy Bierman <[email-masked]>
Date: Fri, 14 Aug 2015 19:47:10 -0700

Hi,

IMO it is a mistake to couple NETCONF or RESTCONF conformance
to the mandatory transport (and message encoding).

For RESTCONF, there should be a capability URI defined for
restconf:1.0 that should be returned by the server.  This just refers to
the protocol operations and data models, not the transport.
RESTCONF over CoAP (or something else) could identify
its functionality with this URI as well.

For NETCONF, there should really be "base:1.1" and "ssh:1.1" capabilities.
The RFC can still make both mandatory.  IMO "base" should not
also imply "ssh".

Andy

On Fri, Aug 14, 2015 at 7:33 PM, Andy Bierman <[email-masked]> wrote:

> Hi,
>
> I did not say the CORE WG is going to standardize RESTCONF over CoAP.
> Their charter is being reviewed now. My preference is to keep CoMI as
> lightweight as possible.
>
> A RESTCONF-over-CoAP server would be non-standard.
> IMO it is not unreasonable to expect the server to support JSON
> to work with RESTCONF clients, to claim RESTCONF conformance.
>
> If there was a standard mapping of RESTCONF to CoAP,
> then the server would claim conformance to that RFC, not RESTCONF.
>
>
> Andy
>
>
> On Fri, Aug 14, 2015 at 4:17 AM, Robert Wilton <[email-masked]> wrote:
>
>>
>> On 13/08/2015 20:03, Kent Watsen wrote:
>>
>>
>> I almost voted "nm" before for this reason and, with the recent info
>> about 406 including supported encodings, I'm now even more open to the
>> idea...
>>
>> I guess that I'm not convinced that either XML or JSON will necessarily
>> end up as the prevalent encoding longer term, I think that one of the more
>> efficient binary encodings will eventually win out.
>>
>> But if RESTCONF mandates XML or JSON now then it seems fairly unlikely
>> that this requirement will be dropped any time in the near future because
>> nobody likes to break backwards compatibility.
>>
>>
>> My only reservation is that I'm torn if interoperability is better
>> achieved by mandate or market forces.
>>
>> Yes, I can emphasise with that view.
>>
>>  If it is outrageously onerous, the CoMI folks can always define
>> "COMICONF" that is a one-line diff to RESTCONF  ;)
>>
>> At the end of the day, I'm also OK with x+j, but felt that nm was
>> slightly better.
>>
>> I guess that what I have proposed really sits between x+j and nm, given
>> that it is weaker than x+j but stronger than nm (i.e. RECOMMENDED rather
>> than OPTIONAL).
>>
>> Thanks,
>> Rob
>>
>>
>>
>> Kent
>>
>> From: Robert Wilton <[email-masked]>
>> Date: Thursday, August 13, 2015 at 5:31 AM
>> To: " <[email-masked]>[email-masked]" <[email-masked]>
>> Subject: Re: [Netconf] Opinion poll for the RESTCONF encoding
>>
>> I seem to be swimming against the tide, but my vote is for nm.
>>
>> More precisely, I would write "A server SHOULD support either XML or JSON
>> encoding.  For maximum interoperability it is RECOMMENDED that both client
>> and servers support both XML and JSON".
>>
>> Justification: Don't cause a server to be non compliant with RESTCONF if
>> they have a specific reason for requiring a different encoding.
>>
>> As for the client/server compatibility issue - I think that market forces
>> will mean that this isn't an issue in practice.
>>
>> Thanks,
>> Rob
>>
>>
>> On 06/08/2015 21:18, Ersue, Mehmet (Nokia - DE/Munich) wrote:
>>
>> Dear NETCONF WG,
>>
>> last October we had an opinion poll on the RESTCONF encoding, which ended
>> with a close consensus in favor of XML as mandatory.
>> See
>> *https://mailarchive.ietf.org/arch/msg/netconf/YSEbLd-nnI0dlkeiIeGW-z6JqDg*
>> <https://mailarchive.ietf.org/arch/msg/netconf/YSEbLd-nnI0dlkeiIeGW-z6JqDg>
>> Based on the recent discussion on this topic and opinions against
>> mandatory statements in RESTCONF, NETCONF WG co-chairs would like to start
>> a new opinion poll.
>>
>> As stated in the mail for the previous poll, the result of the poll
>> depends on the count of people voting.
>> So, all interested NETCONF WG members, please speak up so that we get a
>> better data to judge on WG (rough) consensus.
>> If the voting result is again close, the WG co-chairs will (again)
>> declare consensus in the sake of progress, based on the “dominant view”
>> determined by the co-chairs and AD.
>>
>> Please do state your opinion with short and concrete reasoning, by August
>> 19, 2015 18:00 PST about the following options:
>>
>> x) XML is mandatory, JSON optional,
>> j) JSON is mandatory, XML optional,
>> x&j) XML and JSON are both mandatory,
>> x+j) Either XML or JSON is mandatory the other one is optional,
>> nm) Both XML and JSON are optional and _*not*_ mandatory.
>>
>> For “x+j” and “nm” please provide a solution for a successful negotiation
>> or determination of the encoding to be used between server and client.
>> For the solution discussion a separate thread will be started and can be
>> finalized also after the poll deadline.
>>
>> You may think that one or the other option is useless from your pov. In
>> this case please ignore it.
>>
>> Looking forward to counting your votes and reading your reasoning.
>> Thank you.
>>
>> Best Regards,
>> Mehmet & Mahesh
>>
>>
>>
>>
>> _______________________________________________
>> Netconf mailing [email-masked]://www.ietf.org/mailman/listinfo/netconf
>>
>>
>>
>>
>> _______________________________________________
>> Netconf mailing list
>> [email-masked]
>> https://www.ietf.org/mailman/listinfo/netconf
>>
>>
>